export const alignItems = {
  start: `align-items:flex-start;`,
  center: `align-items:center;`,
  end: `align-items:flex-end;`,
  baseline: `align-items:baseline;`,
  stretch: `align-items:stretch;`,
}
const aiEntries = /*#__PURE__*/ Object.entries(alignItems)

const replaceReducer = (from, to) => (current, [key, value]) => {
  current[key] = value.replace(from, to)
  return current
}

export const alignSelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('items', 'self'),
  {}
)
export const justifySelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('align-items', 'justify-self'),
  {}
)
export const justifyItems = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('align', 'justify'),
  {}
)
export const justifyContent = {
  start: `justify-content:flex-start;`,
  center: `justify-content:center;`,
  end: `justify-content:flex-end;`,
  around: `justify-content:space-around;`,
  between: `justify-content:space-between;`,
  evenly: `justify-content:space-evenly;`,
  stretch: `justify-content:stretch;`,
}
export const alignContent = /*#__PURE__*/ Object.entries(justifyContent).reduce(
  /*#__PURE__*/ replaceReducer('justify', 'align'),
  {}
)
export const flexDirection = {
  row: `flex-direction:row;`,
  column: `flex-direction:column;`,
  reversedRow: `flex-direction:row-reverse;`,
  reversedColumn: `flex-direction:column-reverse;`,
}
